#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>



#define BUFF_SIZE 10000000

int main (int argc, char **argv)
{
	FILE *in;
	int desc_out;
	unsigned short *buffer, *buffer_ptr;
	unsigned short *png;
	unsigned short max;
	unsigned int nb_write, i, j, val, nb = 0, sum = 0, average;

	if ((in = fopen (argv[1], "r")) == NULL)
	{
		perror ("fopen ()");
		return (-1);
	}
	if ((desc_out = open (argv[2], O_WRONLY | 
				O_TRUNC | O_CREAT, 0666)) == -1)
	{
		perror ("fopen ()");
		return (-1);
	}
	buffer = (unsigned short *) malloc 
		(BUFF_SIZE/* * sizeof (unsigned short)*/);
	if (buffer == NULL)
	{
		perror ("malloc ()");
		return (-1);
	}
	while ((fscanf (in, " %d", &val)) != EOF)
	{
		buffer[nb++] = (unsigned short) val;
		sum += val;
	}
	png = (unsigned short *) malloc 
		(((nb * sizeof (unsigned short)) / 5) * 
		 sizeof (unsigned short));
	average = (sum / nb);
	for (i = 0; i < nb; i++)
	{
		buffer[i] = abs (buffer[i] - average);
	}
	buffer_ptr = buffer;
	for (i = 0; i < (nb / 5); i++)
	{
		max = 0;
		for (j = 0; j < 5; j++)
		{
			if (buffer_ptr[j] > max)
			{
				max = buffer_ptr[j];
			}	
		}
		buffer_ptr += 5;
		png[i] = max;
		fprintf (stderr, "max = %d\n", png[i]);
	}	
	nb_write = write (desc_out, (char *) png, 
			(((nb * (sizeof (unsigned short))) / 5) * 
			 sizeof (unsigned short)));
	printf ("%d bytes write\n", nb_write); 
	return (0);
}	
