#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <mem_alloc.h>

#define DFLT_SIZE 500

int main (int argc, char **argv)
{
	int desc, nb_read, i, read_size = (100 * DFLT_SIZE);
	int pass = 0;
	unsigned char buffer[DFLT_SIZE];

	if ((desc = open ("/dev/ppp", O_RDONLY)) == -1)
	{
		perror ("open ()");
		return (-1);
	}
	while ((read_size > 0) && (pass++ < 20))
	{
		memset (buffer, 0, DFLT_SIZE);
		if ((nb_read = read (desc, buffer, DFLT_SIZE)) < 0)
		{
			perror ("read ()");
			return (-1);
		}
		for (i = 0; i < nb_read; i += 2)
		{
			printf ("%d\n", *((unsigned short *) (buffer + i)));
		}
		read_size -= nb_read;
	}
	close (desc);
	return (0);
}	
